//+------------------------------------------------------------------+
//| PipZilla is generated by K. Barsoumian                           |
//|                                                                  |
//|                                                                  |
//|  In no event will author be liable for any damages whatsoever.   |
//|                      Use at your own risk.                       |
//|                                                                  |
//+------------------- DO NOT REMOVE THIS HEADER --------------------+

#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4

#property copyright "K. Barsoumian - PipZilla"
extern bool       useTimeFilter           = true;
extern int        HourBegin               = 4;
extern int        HourEnd                 = 18;
extern int MagicNumber = 1234567890;
extern bool SignalMail = False;
extern bool EachTickMode=True;
extern double  Lots=1.0;
extern int       risk=10;                             // risk to calculate the lots size (only if mm is enabled)
extern double    DecreaseFactor=5;
extern int Slippage=3;
extern bool UseStopLoss=False;
extern int StopLoss=30;
extern bool UseTakeProfit=False;
extern int TakeProfit=1;
extern bool UseTrailingStop=True;
extern int TrailingStop=1;
extern int MA_period=8;
extern int MA_periodSM=18;
extern double BuyOut=-0.0013;
extern double SellOut=0.0013;
extern double OBS=0.0002;

int BarCount;
int Current;
bool TickCheck=False;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   BarCount=Bars;

   if(EachTickMode) Current=0; else Current=1;

   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   int Order=SIGNAL_NONE;
   int Total,Ticket;
   double StopLossLevel,TakeProfitLevel;

   RefreshRates();

   if(EachTickMode && Bars!=BarCount) TickCheck=False;
   Total = OrdersTotal();
   Order = SIGNAL_NONE;

//+------------------------------------------------------------------+
//| Variable Begin                                                   |
//+------------------------------------------------------------------+

   double Base=iMA(NULL,0,1,0,MODE_EMA,PRICE_CLOSE,0);
   double Base1= iMA(NULL,0,1,0,MODE_EMA,PRICE_CLOSE,1);
   double Var1 = iMA(NULL, 0, MA_period, 0, MODE_EMA, PRICE_CLOSE, Current + 0);
   double Var2 = iMA(NULL, 0, MA_period, 0, MODE_EMA, PRICE_CLOSE, Current + 1);
   double Var3 = iMA(NULL, 0, MA_periodSM, 0, MODE_SMA, PRICE_CLOSE, Current + 0);
   double Var4 = iMA(NULL, 0, MA_periodSM, 0, MODE_SMA, PRICE_CLOSE, Current + 1);

   double NowSpace = Var1-Var3;
   double NowSpace2= Var2-Var4;
   double Outcome=NowSpace-NowSpace2;

   Comment("\n","\n","Outcome = ",Outcome);
//+------------------------------------------------------------------+
//| Variable End                                                     |
//+------------------------------------------------------------------+

//Check position
   bool IsTrade=False;

   for(int i=0; i<Total; i++)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))continue;
      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol())
        {
         IsTrade=True;
         if(OrderType()==OP_BUY)
           {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Buy)                                           |
            //+------------------------------------------------------------------+

            if(Base<Var3 && Outcome<BuyOut)Order=SIGNAL_CLOSEBUY;

            //+------------------------------------------------------------------+
            //| Signal End(Exit Buy)                                             |
            //+------------------------------------------------------------------+

            if(Order==SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars!=BarCount))))
              {
               OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,MediumSeaGreen);
               if(SignalMail) SendMail("[Signal Alert]","["+Symbol()+"] "+DoubleToStr(Bid,Digits)+" Close Buy");
               if(!EachTickMode) BarCount=Bars;
               IsTrade=False;
               continue;
              }
            //Trailing stop
            if(UseTrailingStop && TrailingStop>0)
              {
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,MediumSeaGreen);
                     if(!EachTickMode) BarCount=Bars;
                     continue;
                    }
                 }
              }
              } else {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Sell)                                          |
            //+------------------------------------------------------------------+

            if(Base>Var3 && Outcome>SellOut)Order=SIGNAL_CLOSESELL;

            //+------------------------------------------------------------------+
            //| Signal End(Exit Sell)                                            |
            //+------------------------------------------------------------------+

            if(Order==SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars!=BarCount))))
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,DarkOrange);
               if(SignalMail) SendMail("[Signal Alert]","["+Symbol()+"] "+DoubleToStr(Ask,Digits)+" Close Sell");
               if(!EachTickMode) BarCount=Bars;
               IsTrade=False;
               continue;
              }
            //Trailing stop
            if(UseTrailingStop && TrailingStop>0)
              {
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,DarkOrange);
                     if(!EachTickMode) BarCount=Bars;
                     continue;
                    }
                 }
              }
           }
        }
     }

//+------------------------------------------------------------------+
//| Signal Begin(Entry)                                              |
//+------------------------------------------------------------------+
   if(WorkTime())
     {
      if(Base>Var1 && Var1>Var2 && Base>Base1 && NowSpace>NowSpace2 && Outcome>OBS)Order=SIGNAL_BUY;
      if(Base<Var1 && Var1<Var2 && Base<Base1 && NowSpace2>NowSpace && Outcome<-OBS)Order=SIGNAL_SELL;
     }
//+------------------------------------------------------------------+
//| Signal End                                                       |
//+------------------------------------------------------------------+

//Buy
   if(Order==SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars!=BarCount))))
     {
      if(!IsTrade)
        {

         if(UseStopLoss) StopLossLevel=Ask-StopLoss*Point; else StopLossLevel=0.0;
         if(UseTakeProfit) TakeProfitLevel=Ask+TakeProfit*Point; else TakeProfitLevel=0.0;

         Ticket=OrderSend(Symbol(),OP_BUY,GetLots(),Ask,Slippage,StopLossLevel,TakeProfitLevel,"Buy(#"+MagicNumber+")",MagicNumber,0,LawnGreen);
         if(Ticket>0)
           {
            if(OrderSelect(Ticket,SELECT_BY_TICKET,MODE_TRADES))
              {
               Print("BUY order opened : ",OrderOpenPrice());
               if(SignalMail) SendMail("[Signal Alert]","["+Symbol()+"] "+DoubleToStr(Ask,Digits)+" Open Buy");
                 } else {
               Print("Error opening BUY order : ",GetLastError());
              }
           }
         if(EachTickMode) TickCheck = True;
         if(!EachTickMode) BarCount = Bars;
         return(0);
        }
     }

//Sell
   if(Order==SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars!=BarCount))))
     {
      if(!IsTrade)
        {

         if(UseStopLoss) StopLossLevel=Bid+StopLoss*Point; else StopLossLevel=0.0;
         if(UseTakeProfit) TakeProfitLevel=Bid-TakeProfit*Point; else TakeProfitLevel=0.0;

         Ticket=OrderSend(Symbol(),OP_SELL,GetLots(),Bid,Slippage,StopLossLevel,TakeProfitLevel,"Sell(#"+MagicNumber+")",MagicNumber,0,Red);
         if(Ticket>0)
           {
            if(OrderSelect(Ticket,SELECT_BY_TICKET,MODE_TRADES))
              {
               Print("SELL order opened : ",OrderOpenPrice());
               if(SignalMail) SendMail("[Signal Alert]","["+Symbol()+"] "+DoubleToStr(Bid,Digits)+" Open Sell");
                 } else {
               Print("Error opening SELL order : ",GetLastError());
              }
           }
         if(EachTickMode) TickCheck = True;
         if(!EachTickMode) BarCount = Bars;
         return(0);
        }
     }

   if(!EachTickMode) BarCount=Bars;

   return(0);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool WorkTime()
  {
   if(!useTimeFilter) return true;
   int currHour=TimeHour(TimeCurrent());
   if(HourBegin<HourEnd && currHour>=HourBegin && currHour<HourEnd)return true;
   if(HourBegin>=HourEnd && (currHour>=HourBegin || currHour<HourEnd))return true;
   return false;
  }
//+------------------------------------------------------------------+
double GetLots()
  {
   double _sl=StopLoss;
   double lot=Lots;
   double MinLots=MarketInfo(Symbol(),MODE_MINLOT);
   double MaxLots=MarketInfo(Symbol(),MODE_MAXLOT);
   double TickVal=MarketInfo(Symbol(),MODE_TICKVALUE);
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
   int digLots=0;
   if(MinLots<0.1)digLots=2;
   else
      if(MinLots<1)digLots=1;
//--- select lot size
   if(_sl<=0 || !UseStopLoss)_sl=iATR(Symbol(),PERIOD_D1,8,1)/Point;
   if(risk>0) lot=NormalizeDouble(AccountFreeMargin()*risk/100/TickVal/_sl,digLots);
//--- calcuulate number of losses orders without a break
   if(DecreaseFactor!=0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false)
           {
            Print("Error in history!");
            break;
           }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL)
            continue;
         //---
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1)
         lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,digLots);
     }
//--- return lot size
   return(MathMin(MaxLots,MathMax(MinLots,lot)));
  }
//+------------------------------------------------------------------+
